// rttiDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rtti.h"
#include "rttiDlg.h"

#include "Cprostokat.h"
#include "Ctxt.h"
#include "CrectTxt.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CrttiDlg dialog




CrttiDlg::CrttiDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CrttiDlg::IDD, pParent), lista(Cpunkt(500,100), Cpunkt(960,600), "")
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CrttiDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CrttiDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CrttiDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CrttiDlg::OnBnClickedButton2)
END_MESSAGE_MAP()


// CrttiDlg message handlers

BOOL CrttiDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	p.open("strumienie.log");
	p<< "Inicjalizacja";


	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CrttiDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{

		CPaintDC dc(this); // device context for painting
		
		for(int i=0;i<tabfig.size()+1;++i)
		{
			try{
				if(tabfig[i]==NULL) throw Blad_Tablicy("CrttiDlg::OnPaint");
				tabfig[i]->rysuj(&dc);
				tabfig[i]->print(p);
			}
			catch(PozaZasiegiem & e)
			{
				tabstr.push_back("PozaZasiegiem:");
				tabstr.push_back(e.what());
			}
			catch(Blad_Danych & e)
			{
				tabstr.push_back("Blad_Danych:");
				tabstr.push_back(e.what());
			
			}
			catch(Blad_Tablicy & e)
			{
				tabstr.push_back("Blad_Tablicy:");
				tabstr.push_back(e.what());
			
			}
			catch(Wyjatek & e)
			{
				tabstr.push_back("Wyjatek:");
				tabstr.push_back(e.what());
			
			}
			catch(...)
			{
				tabstr.push_back("!!!!!!!innyWyjatek!!!!");
			
			}
				}



		lista.setText("");
		for(int i=0;i<tabstr.size();++i)
		{
			lista.addText(tabstr[i].c_str());
			lista.addText("\n");
		}

		lista.rysuj(&dc);
		/*dc.MoveTo(100,100);
		dc.LineTo(50,50);*/


		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CrttiDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}




void CrttiDlg::OnBnClickedButton1()
{
	CString txt;
	GetDlgItemText(IDC_EDIT1,txt);
	
	try{
		addFigure(txt);
	}catch(BrakMiejsca & e)
	{
		tabstr.push_back("BrakMiejsca:");
		tabstr.push_back(e.what());
	}
	catch(Blad_Danych & e)
	{
		tabstr.push_back("Blad_Danych:");
		tabstr.push_back(e.what());
	
	}
	catch(Wyjatek & e)
	{
		tabstr.push_back("Wyjatek:");
		tabstr.push_back(e.what());
	
	}
	catch(...)
	{
		tabstr.push_back("!!!!!!!innyWyjatek!!!!");
	
	}



	Invalidate(true);
}



void CrttiDlg::OnBnClickedButton2()
{
	DestroyFigures();
	
	tabfig.clear();
	tabstr.clear();

	Invalidate(true);
}

void CrttiDlg::addFigure(CString & fig)
{
	Cfigura * f = NULL;


	if(fig[0]=='p')
	{
		if(fig.GetLength()>1 && fig[1]=='d')
		{
			f= new Cprostokat(Cpunkt(100,100),Cpunkt(1050,670));
			tabstr.push_back("Prostokat [100,100,1050,670]");
		}
		else
		{
			f= new Cprostokat(Cpunkt(5,5),Cpunkt(100,100));
			tabstr.push_back("Prostokat [5,5,100,100]");
		}
	}	
	else if(fig[0]=='t')
	{
		f=new Ctxt("Test", Cpunkt(200,200));
		tabstr.push_back("Tekst [200,200]");
	}
	else if(fig[0]=='e')
	{
		f=new CrectTxt(Cpunkt(100,100),Cpunkt(150,150),"Test");
		tabstr.push_back("RectText [100,100,150,150]");
	}
	else if(fig=="null")
	{
		tabstr.push_back("NULL");
	}
	else
	{	
		throw Blad_Danych("CrttiDlg:addFigure");
	}
	
	try{	
	tabfig.push_back(f);
	}catch(BrakMiejsca & e)
	{
		delete f;
		throw;
	}

}


void CrttiDlg::DestroyFigures()
{
		for(int i=0;i<tabfig.size();++i)
		delete tabfig[i];

}